local addonName = ...
local HushNowFrame = CreateFrame("Frame")
HushNowFrame.IgnoreListVO = {
-- Hardcoded Ignores
[69296] = true, -- Use Caution. We don't want our withered to end up in cacoons. I think we got the point.
[70959] = true, -- Greymanes Forces hold this warden tower. 
}
HushNowFrame.IgnoreListNPC = {

}
HushNowFrame.ImportantMessages = {
[69293] = true, -- One of the withered is running away. Catch him before he is lost in the tunnels
}

function HushNowFrame:print(text)
DEFAULT_CHAT_FRAME:AddMessage("[HushNow]: "..text, 0, 1, 0)
end
local function PrintMessage(text) HushNowFrame:print(text); end

HushNowFrame.LastTH = nil
HushNowFrame.CurrentSpeakerIgnored = false

HushNowFrame.IgnoreManager = CreateFrame("Frame", nil, HushNowFrame, "BasicFrameTemplateWithInset")
HushNowFrame.IgnoreManager:Hide()
HushNowFrame.IgnoreManager.TitleText:SetText("HushNow - Ignore Manager")
HushNowFrame.IgnoreManager:EnableMouse(true) 
HushNowFrame.IgnoreManager:SetWidth(640)
HushNowFrame.IgnoreManager:SetHeight(242)
HushNowFrame.IgnoreManager:SetPoint("TOP",BossBanner,"TOP")
HushNowFrame.IgnoreManager.ButtonContainer = CreateFrame("Frame", HushNowFrame.IgnoreManager)
HushNowFrame.IgnoreManager.ButtonContainer:EnableMouse(true)
HushNowFrame.IgnoreManager.ButtonContainer:SetParent(HushNowFrame.IgnoreManager)
--HushNowFrame.IgnoreManager.ButtonContainer.texture = HushNowFrame.IgnoreManager.ButtonContainer:CreateTexture(nil, "BACKGROUND")
--HushNowFrame.IgnoreManager.ButtonContainer.texture:SetAllPoints(true)
--HushNowFrame.IgnoreManager.ButtonContainer.texture:SetColorTexture(0.0, 1.0, 0.0, 1)
HushNowFrame.IgnoreManager.ButtonContainer:SetPoint("TOPLEFT", 6, -26)
HushNowFrame.IgnoreManager.ButtonContainer:SetPoint("BOTTOMRIGHT", -10, 10)
HushNowFrame.IgnoreManager.ButtonContainer.Buttons = {}
HushNowFrame.IgnoreManager.ButtonContainer.ButtonLimit = 6
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar = CreateFrame("Slider", nil, HushNowFrame.IgnoreManager.ButtonContainer, "UIPanelScrollBarTemplate") 
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:SetPoint("TOPRIGHT", HushNowFrame.IgnoreManager.ButtonContainer, "TOPRIGHT",0,-18)
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:SetPoint("BOTTOM", HushNowFrame.IgnoreManager.ButtonContainer, "BOTTOM", 0, 12)
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:SetMinMaxValues(1, 100)
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:SetValueStep(1)
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar.scrollStep = 1
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:SetWidth(16)
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar.texture = HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:CreateTexture(nil, "BACKGROUND")
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar.texture:SetAllPoints(HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar)
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar.texture:SetColorTexture(0, 0, 0, 0.4) 
function HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:OnScroll(value)
local ButtonContainer = self:GetParent()
ButtonContainer.offset = max(floor(value)-1,0)
ButtonContainer:UpdateButtons()
end
function HushNowFrame.IgnoreManager.ButtonContainer:OnMouseWheel(dir)
local minValue, maxValue = self.ScrollBar:GetMinMaxValues()
local currValue = self.ScrollBar:GetValue()
if(dir == -1)then
self.ScrollBar:SetValue(math.min(self.ScrollBar:GetValue()+1,maxValue))
else
self.ScrollBar:SetValue(math.max(self.ScrollBar:GetValue()-1,minValue))
end
end
HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar:SetScript("OnValueChanged",HushNowFrame.IgnoreManager.ButtonContainer.ScrollBar.OnScroll) 
HushNowFrame.IgnoreManager.ButtonContainer:SetScript("OnMouseWheel", HushNowFrame.IgnoreManager.ButtonContainer.OnMouseWheel)

function HushNowFrame.IgnoreManager.ButtonContainer:DeleteClicked(button,down)
local buttonFrame = self:GetParent()
local ButtonContainer = buttonFrame:GetParent()
local IgnoreManager = ButtonContainer:GetParent()
local HushNowFrame = IgnoreManager:GetParent()
if(buttonFrame.ignoreType == "VO")then
PrintMessage("Removed Ignore For VO ["..HushNow_IgnoreList["VO"][buttonFrame.ignoreData].text.."] - "..HushNow_IgnoreList["VO"][buttonFrame.ignoreData].name)
HushNow_IgnoreList["VO"][buttonFrame.ignoreData] = nil
HushNowFrame.IgnoreListVO[buttonFrame.ignoreData] = nil
end
if(buttonFrame.ignoreType == "NPC")then
PrintMessage("Removed Ignore For NPC ["..HushNow_IgnoreList["NPC"][buttonFrame.ignoreData].."]")
HushNow_IgnoreList["NPC"][buttonFrame.ignoreData] = nil
HushNowFrame.IgnoreListNPC[buttonFrame.ignoreData] = nil
end
ButtonContainer:UpdateButtons()
end

function HushNowFrame.IgnoreManager.ButtonContainer:GetButton(index)
if(index > self.ButtonLimit)then return; end
if(self.Buttons[index])then return self.Buttons[index]; end
local nextIndex = #self.Buttons+1
if(index == nextIndex)then
self.Buttons[nextIndex] = CreateFrame("Frame")
local frame = self.Buttons[nextIndex]
if(index == 1)then
frame:SetPoint("TOP",self,"TOP",0,-5)
else
frame:SetPoint("TOP", self.Buttons[index-1],"BOTTOM",0,-2)
end
frame:SetPoint("LEFT",self,"LEFT",5,0)
frame:SetPoint("RIGHT",self.ScrollBar,"LEFT",-5,0)
frame:SetHeight(32)
frame.texture = frame:CreateTexture(nil, "BACKGROUND")
frame.texture:SetAllPoints(true)
frame.texture:SetColorTexture(0.2, 0.2, 0.2, 0.5)
frame.speakerName = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
frame.speakerName:SetHeight(10)
frame.speakerName:SetPoint("TOPLEFT", frame, "TOPLEFT",3,-3)
frame.speakerName:SetText("SPEAKER")
frame.speakerName:SetJustifyH("LEFT")
frame.speechText = frame:CreateFontString(nil, "OVERLAY", "ChatFontNormal")
frame.speechText:SetHeight(10)
frame.speechText:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT",3,3)
frame.speechText:SetText("TEXT")
frame.speechText:SetJustifyH("LEFT")
--frame.speechText:Hide()
frame.deleteIgnore = CreateFrame("Button", nil, frame,"UIPanelButtonTemplate")
frame.deleteIgnore:SetHeight(16)
frame.deleteIgnore:SetWidth(60)
frame.deleteIgnore:SetText("Delete")
frame.deleteIgnore:SetScript("OnClick",self.DeleteClicked)
frame.deleteIgnore:SetPoint("TOPRIGHT", frame,"TOPRIGHT",-2,-2)
frame.speakerName:SetPoint("RIGHT", frame.deleteIgnore, "LEFT",-2,0)
frame.speechText:SetPoint("RIGHT", frame.deleteIgnore, "LEFT",-2,0)
frame:SetParent(self)
frame:Hide()
return frame
end
end


function HushNowFrame.IgnoreManager.ButtonContainer:UpdateButtons()
if(type(HushNow_IgnoreList) == "table" and type(HushNow_IgnoreList["NPC"]) == "table" and type(HushNow_IgnoreList["VO"] == "table"))then
local ignoreIndex = 0
local buttonIndex = 0
local buttonOffset = (tonumber(self.offset) or 0)

for displayID, name in pairs(HushNow_IgnoreList["NPC"]) do
ignoreIndex = ignoreIndex + 1
if(ignoreIndex > buttonOffset)then
buttonIndex = buttonIndex + 1
local button = self:GetButton(buttonIndex)
if(button)then
button.speakerName:SetText(name)
button.speechText:Hide()
button.ignoreType = "NPC"
button.ignoreData = displayID
button:Show()
end
end
end

for VOId, data in pairs(HushNow_IgnoreList["VO"]) do
ignoreIndex = ignoreIndex + 1
if(ignoreIndex > buttonOffset)then
buttonIndex = buttonIndex + 1
local button = self:GetButton(buttonIndex)
if(button)then
button.speakerName:SetText(data.name)
button.speechText:SetText(data.text)
button.speechText:Show()
button.ignoreType = "VO"
button.ignoreData = (data.VO or VOId)
button:Show()
end
end
end

for i = buttonIndex + 1,#self.Buttons do
local button = self:GetButton(i)
if(button)then button:Hide(); end
end

if(ignoreIndex <= self.ButtonLimit)then
self.ScrollBar:SetValue(1)
self.ScrollBar:Hide()
for i = 1, #self.Buttons do
local button = self:GetButton(i)
if(button)then button:SetPoint("RIGHT",self,"RIGHT",-5,0); end
end
else
for i = 1, #self.Buttons do
local button = self:GetButton(i)
if(button)then button:SetPoint("RIGHT",self.ScrollBar,"LEFT",-5,0); end
end
self.ScrollBar:Show()
end
self.ScrollBar:SetMinMaxValues(1, max((ignoreIndex-(self.ButtonLimit-1)),1))
end
end

HushNowFrame.IgnoreManager.ButtonContainer:SetScript("OnShow",function(self) self:UpdateButtons(); end)

StaticPopupDialogs["HUSHNOW_IGNORE_TALKINGHEAD"] = {
	text = "HUSHNOW_IGNORE_DIALOG",
	button1 = "Ignore NPC",
	button2 = "Ignore Voiceover",
	button3 = "Cancel",
	OnAccept = function (self)
		if(not self.data)then
			return
		end
		PrintMessage(""..self.data.name.." is now being ignored.")
		self.data.HushNowFrame.IgnoreListNPC[self.data.displayInfo] = true
		if(self.data.HushNowFrame.LoadedVariables)then
			HushNow_IgnoreList["NPC"][self.data.displayInfo] = self.data.name
			if(self.data.HushNowFrame.IgnoreManager:IsShown())then
				self.data.HushNowFrame.IgnoreManager.ButtonContainer:UpdateButtons()
			end
		end
	end,
	OnCancel = function (self)
		if(not self.data)then
			return
		end
		PrintMessage("Ignoring VO ["..self.data.text.."]")
		self.data.HushNowFrame.IgnoreListVO[self.data.vo] = true
		if(self.data.HushNowFrame.LoadedVariables)then
			HushNow_IgnoreList["VO"][self.data.vo] = {["displayInfo"] = self.data.displayInfo,["name"] = self.data.name,["text"] = self.data.text}
		end
	end,
	OnShow = function(self)
		if(not self.data or not self.data.HushNowFrame)then
		self:Hide()
		return
		end
		
		
		self.text:SetText("Hush Now\n\nNPC: "..self.data.name.."\nMessage: "..self.data.text)
		
		if(HushNow_Config["showImportant"] == true and (tonumber(self.data.vo) and self.data.HushNowFrame.ImportantMessages[tonumber(self.data.vo)] == true))then
		self.text:SetText("Hush Now\n\nNPC: "..self.data.name.."\nMessage: "..self.data.text.."\n\nIgnoring this TalkingHead will only disable the chat box as it is important.\n\nThis feature can be disabled with /hushnow showimportant")
		end
		
		if(self.data["silent"] == true)then
		self.button2:Disable()
		self.text:SetText("Hush Now\n\nNPC: "..self.data.name.."\nMessage: "..self.data.text.."\n\nThis TalkingHead has no audio.")
		else
		self.button2:Enable()
		end
	
	end,
	OnHide = function (self)
		self.data = nil
	end,
	hideOnEscape = false,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
}

function HushNowFrame:Ignore()
if(self.LastTH)then
local data = self.LastTH
data.HushNowFrame = self
self.IgnoreManager:Hide()
local dialog = StaticPopup_Show("HUSHNOW_IGNORE_TALKINGHEAD",nil,nil,data)
else
PrintMessage("No Talking Heads Shown")
end
end


local HushNowSlashCMDHandler = function(msg)
local command = strlower(msg)
if(command == "reset")then
wipe(HushNow_IgnoreList)
ReloadUI()
return
end
if(command == "ignore")then
HushNowFrame:Ignore()
return
end
if(command == "manage")then
if(HushNowFrame.IgnoreManager:IsShown())then
HushNowFrame.IgnoreManager:Hide()
else
HushNowFrame.IgnoreManager:Show()
end
return
end
if(command == "showimportant")then
if(HushNow_Config["showImportant"] == true)then
HushNow_Config["showImportant"] = false
PrintMessage("Important messages will not play if ignored")
else
HushNow_Config["showImportant"] = true
PrintMessage("Important messages will play even if ignored")
end

return
end

local usageInfo = {
"Usage",
"/hushnow ignore : Display Ignore Dialoge for last talking head",
"/hushnow showimportant  : Toggle forcing audio to play for ignored messages if they are important",
"/hushnow manage  : Shows/Hides Ignore Manager",
"/hushnow reset  : Reset Settings (Reloads UI)",
}
PrintMessage(strjoin("\n", unpack(usageInfo)))

end

SLASH_HUSHNOW1 = '/hushnow'
SlashCmdList["HUSHNOW"] = HushNowSlashCMDHandler


function HushNowFrame:OnEvent(evt,...)
if(evt == "ADDON_LOADED")then
local loadedAddon = ...
if(loadedAddon == addonName)then
if(HushNow_IgnoreList == nil)then HushNow_IgnoreList = {}; end
if(HushNow_IgnoreList["VO"] == nil)then HushNow_IgnoreList["VO"] = {}; end
if(HushNow_IgnoreList["NPC"] == nil)then HushNow_IgnoreList["NPC"] = {}; end
if(HushNow_Config == nil)then HushNow_Config = {}; end
if(not HushNow_Config["showImportant"] == true)then HushNow_Config["showImportant"] = false; end

for i,v in pairs(HushNow_IgnoreList["VO"]) do
self.IgnoreListVO[i] = true
end
for i,v in pairs(HushNow_IgnoreList["NPC"]) do
self.IgnoreListNPC[i] = true
end
self.LoadedVariables = true
PrintMessage("Addon Loaded")
end
end



if(evt == "TALKINGHEAD_REQUESTED")then
local displayInfo, cameraID, vo, duration, lineNumber, numLines, name, text, isNewTalkingHead, textureKit = C_TalkingHead.GetCurrentLineInfo();
local silentVO = false
if(vo == 0)then
silentVO = true
vo = text
end
if(isNewTalkingHead)then
self.CurrentSpeakerIgnored = false
end

if(displayInfo and vo and name and text)then
self.LastTH = {["displayInfo"] = displayInfo,["vo"] = vo,["name"] = name,["text"] = text,["silent"] = silentVO,}
end

if((not self.CurrentSpeakerIgnored == true) and (silentVO == false and (tonumber(vo) and not(self.IgnoreListVO[tonumber(vo)] == true)) or (silentVO == true and self.IgnoreListVO[vo] == true)) and (tonumber(displayInfo) and not(self.IgnoreListNPC[tonumber(displayInfo)] == true)))then

if(not TalkingHeadFrame.MainFrame.CloseButton.NTHhookFrame)then
local closeButton = TalkingHeadFrame.MainFrame.CloseButton
closeButton.NTHhookFrame = self
closeButton:SetScript("OnClick",function(self,btn,down)
local NTHFrame = self.NTHhookFrame
TalkingHeadFrame:CloseImmediately()
if(IsShiftKeyDown())then
NTHFrame:Ignore()
end
end)
end
TalkingHeadFrame:PlayCurrent()
else
if((tonumber(vo) and (self.IgnoreListVO[tonumber(vo)] == true)) or (tonumber(displayInfo) and (self.IgnoreListNPC[tonumber(displayInfo)] == true)))then
--TalkingHeadFrame_CloseImmediately()
self.CurrentSpeakerIgnored = true
end
if(tonumber(vo) and self.ImportantMessages[tonumber(vo)])then
-- Sorry you need to hear this one (At least if you enabled the option to hear important ones)
local success, voHandle = PlaySound(vo, "Talking Head", true, true)
end


end


end

end

function HushNowFrame:Init()
self:RegisterEvent("TALKINGHEAD_REQUESTED")
UIParent:UnregisterEvent("TALKINGHEAD_REQUESTED")
TalkingHeadFrame:UnregisterEvent("TALKINGHEAD_REQUESTED")
self:RegisterEvent("ADDON_LOADED")
self:SetScript("OnEvent", self.OnEvent)
self:SetScript("OnUpdate", self.OnUpdate)
end
HushNowFrame:Init()